
#include <exec/types.h>
#include <exec/exec.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <libraries/dos.h>
#include <libraries/dosextens.h>
#include <stdio.h>
#include <midi/midi.h>
#include <functions.h>
#include <fcntl.h>

#define VERSION 33L	/* 1.2 Library Version	*/

#define g0	0
#define g1	1
#define g2	2
#define g3	3
#define g4	4
#define g5	5
#define g6	6
#define g7	7
#define g8	8
#define g9	9
#define g10	10
#define g11	11
#define g12	12
#define g13	13
#define g14	14
#define g15	15
#define g16	16

SHORT BorderVectors1[] = {
	0,0,
	29,0,
	29,12,
	0,12,
	0,0
};
struct Border Border1 = {
	-2,-1,	/* XY origin relative to container TopLeft */
	1,0,JAM2,	/* front pen, back pen and drawmode */
	5,	/* number of XY vectors */
	BorderVectors1,	/* pointer to XY vectors */
	NULL	/* next border in list */
};
SHORT BorderVectors2[] = {
	0,0,
	38,0,
	38,12,
	0,12,
	0,0
};
struct Border Border2 = {
	-2,-1,	/* XY origin relative to container TopLeft */
	1,0,JAM2,	/* front pen, back pen and drawmode */
	5,	/* number of XY vectors */
	BorderVectors2,	/* pointer to XY vectors */
	NULL	/* next border in list */
};
struct Border Border3 = {
	-9,-3,	/* XY origin relative to container TopLeft */
	1,0,JAM2,	/* front pen, back pen and drawmode */
	5,	/* number of XY vectors */
	BorderVectors2,	/* pointer to XY vectors */
	NULL	/* next border in list */
};

struct IntuiText IText2 = {
	1,0,JAM1,	/* front and back text pens, drawmode and fill byte */
	-202,2,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"System Exclusive Channel",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct IntuiText IText1 = {
	1,0,JAM2,	/* front and back text pens, drawmode and fill byte */
	8,2,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"16",	/* pointer to text */
	&IText2	/* next IntuiText structure */
};

struct Gadget Gadget1 = {
	NULL,	/* next gadget */
	214,13,	/* origin XY of hit box relative to window TopLeft */
	35,11,	/* hit box width and height */
	NULL,	/* gadget flags */
	RELVERIFY,	/* activation flags */
	BOOLGADGET,	/* gadget type flags */
	(APTR)&Border2,	/* gadget border or image to be rendered */
	NULL,	/* alternate imagery for selection */
	&IText1,	/* first IntuiText structure */
	NULL,	/* gadget mutual-exclude long word */
	NULL,	/* SpecialInfo structure */
	NULL,	/* user-definable data */
	NULL	/* pointer to user-definable data */
};

#define GadgetList1 Gadget1

struct IntuiText IText3 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	19,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Other (No Checking)",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem5 = {
	NULL,	/* next MenuItem structure */
	0,36,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	243,9,	/* hit box width and height */
	CHECKIT+ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP+CHECKED,	/* Item flags */
	0xffef,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText3,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	'q',	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText4 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	19,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Matrix 6",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem4 = {
	&MenuItem5,	/* next MenuItem structure */
	0,27,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	243,9,	/* hit box width and height */
	CHECKIT+ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0xfff7,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText4,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	'm',	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText5 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	19,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"TX81Z",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem3 = {
	&MenuItem4,	/* next MenuItem structure */
	0,18,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	243,9,	/* hit box width and height */
	CHECKIT+ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0xfffb,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText5,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	't',	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText6 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	19,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"FB-01",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem2 = {
	&MenuItem3,	/* next MenuItem structure */
	0,9,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	243,9,	/* hit box width and height */
	CHECKIT+ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0xfffd,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText6,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	'f',	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText7 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	19,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"DX7 TX7 DX27 DX21 DX100",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem1 = {
	&MenuItem2,	/* next MenuItem structure */
	0,0,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	243,9,	/* hit box width and height */
	CHECKIT+ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0xfffe,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText7,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	'd',	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct Menu Menu3 = {
	NULL,	/* next Menu structure */
	263,0,	/* XY origin of Menu hit box relative to screen TopLeft */
	138,0,	/* Menu hit box width and height */
	MENUENABLED,	/* Menu flags */
	"Error Checking",	/* text of Menu name */
	&MenuItem1	/* MenuItem linked list pointer */
};

struct IntuiText IText8 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Master Data",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem SubItem3 = {
	NULL,	/* next SubItem structure */
	113,18,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	104,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText8,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* no SubItem list for SubItems */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText9 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Splits Data",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem SubItem2 = {
	&SubItem3,	/* next SubItem structure */
	113,9,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	104,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText9,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* no SubItem list for SubItems */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText10 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Single Voice",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem SubItem1 = {
	&SubItem2,	/* next SubItem structure */
	113,0,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	104,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText10,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* no SubItem list for SubItems */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText11 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Matrix 6",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem9 = {
	NULL,	/* next MenuItem structure */
	0,27,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	128,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText11,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	&SubItem1,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText12 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Voice Bank",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem SubItem4 = {
	NULL,	/* next SubItem structure */
	124,0,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	88,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText12,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* no SubItem list for SubItems */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText13 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"DX21 DX27 DX100",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem8 = {
	&MenuItem9,	/* next MenuItem structure */
	0,18,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	128,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText13,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	&SubItem4,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText14 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Configuration Bank",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem SubItem6 = {
	NULL,	/* next SubItem structure */
	110,9,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	152,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText14,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* no SubItem list for SubItems */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText15 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Voice Bank",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem SubItem5 = {
	&SubItem6,	/* next SubItem structure */
	110,0,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	152,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	0,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText15,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* no SubItem list for SubItems */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText16 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"FB-01",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem7 = {
	&MenuItem8,	/* next MenuItem structure */
	0,9,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	128,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	13,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText16,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	&SubItem5,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct IntuiText IText17 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	4,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"TX7",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem6 = {
	&MenuItem7,	/* next MenuItem structure */
	0,0,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	128,9,	/* hit box width and height */
	ITEMTEXT+ITEMENABLED+HIGHCOMP,	/* Item flags */
	14,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText17,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	NULL,	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct Menu Menu2 = {
	&Menu3,	/* next Menu structure */
	136,0,	/* XY origin of Menu hit box relative to screen TopLeft */
	120,0,	/* Menu hit box width and height */
	MENUENABLED,	/* Menu flags */
	"Dump Request",	/* text of Menu name */
	&MenuItem6	/* MenuItem linked list pointer */
};

struct IntuiText IText18 = {
	0,1,JAM2,	/* front and back text pens, drawmode and fill byte */
	0,1,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"Send SYS-EX File",	/* pointer to text */
	NULL	/* next IntuiText structure */
};

struct MenuItem MenuItem10 = {
	NULL,	/* next MenuItem structure */
	0,0,	/* XY of Item hitbox relative to TopLeft of parent hitbox */
	172,9,	/* hit box width and height */
	ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,	/* Item flags */
	1,	/* each bit mutually-excludes a same-level Item */
	(APTR)&IText18,	/* Item render  (IntuiText or Image or NULL) */
	NULL,	/* Select render */
	'z',	/* alternate command-key */
	NULL,	/* SubItem list */
	MENUNULL	/* filled in by Intuition for drag selections */
};

struct Menu Menu1 = {
	&Menu2,	/* next Menu structure */
	0,0,	/* XY origin of Menu hit box relative to screen TopLeft */
	129,9,	/* Menu hit box width and height */
	MENUENABLED,	/* Menu flags */
	"File Transmit",	/* text of Menu name */
	&MenuItem10	/* MenuItem linked list pointer */
};

#define MenuList1 Menu1

struct NewWindow NewWindowStructure1 = {
	74,20,	/* window XY origin relative to TopLeft of screen */
	264,60,	/* window width and height */
	0,1,	/* detail and block pens */
	GADGETUP+MENUPICK+CLOSEWINDOW+REQSET,	/* IDCMP flags */
	WINDOWDRAG+WINDOWDEPTH+WINDOWCLOSE+ACTIVATE+NOCAREREFRESH,	/* other window flags */
	&Gadget1,	/* first gadget in gadget list */
	NULL,	/* custom CHECKMARK imagery */
	(UBYTE *)"Sys-Ex Filer",	/* window title */
	NULL,	/* custom screen pointer */
	NULL,	/* custom bitmap */
	264,60,	/* minimum width and height */
	266,60,	/* maximum width and height */
	WBENCHSCREEN	/* destination screen type */
};


/* end of PowerWindows source generation */
